{#
Result component, used by UteResult formatter.

See blueprint: \Geeks4change\UntrackEmailAnalyzer\TextReportCreator

Called from \Drupal\untrack_email_storage\Plugin\Field\FieldFormatter\UteResult

More info to components:
https://git.drupalcode.org/project/cl_components/-/blob/1.x/docs/writing-components.md
https://git.drupalcode.org/project/cl_components/-/blob/1.x/docs/rendering-components.md
#}

{# Variables: (in separete comment for IDE autocompletion (needs PhpStorm with Symfony plugin), #}
{# result \Geeks4change\UntrackEmailAnalyzer\Analyzer\Result\Result #}

{# sdcAttributes contains data-sdc-id and component classes. #}
{# https://www.drupal.org/docs/8/theming-drupal-8/using-attributes-in-templates #}
{# result.verdict.matchLevel \Geeks4change\UntrackEmailAnalyzer\Analyzer\Verdict\ResultVerdictMatchLevel #}
{# sure|likely|unknown|unlikely #}
{% set sdcAttributes = sdcAttributes.addClass("ute-result-match-level-#{result.verdict.matchLevel.value}") %}

<div {{ sdcAttributes }}>

      <div class="sender">
        <h2>Analysis of
        {{ result.listInfo.emailLabel }} &lt;{{ result.listInfo.emailAddress }}&gt;</h2></div>
        <p><strong>from <date>{{ result.messageInfo.timeStamp|date('Y-m-d H:i:s') }}</date></strong></p>

      <div class="verdict">
        <label>{{"Verdict" }}:</label>
      {{ result.verdict.serviceName }} (Match level: {{ result.verdict.matchLevel.value }})</div>

      {# <h2>{{"Full analysis" }}</h2> #}
      {# Nothing more in details than in summary. #}
      <h3>{{"DKIM Result" }}</h3>
      {{"Signature verification confidence: " }}
      {{ result.details.dkimResult.status.value }}
      {# <details>
      <summary>{{"Details:" }}</summary>
      {% for dkimSummaryLine in result.summary.dkimResult.summaryLines %}
        {{ dkimSummaryLine }}
      {% endfor %}
      </details> #}

      <h3>{{"Headers result" }}</h3>
      {# headerItemInfoBag \Geeks4change\UntrackEmailAnalyzer\Analyzer\Result\Header\HeaderItemInfoBag #}
      {% with { headerItemInfoBag: result.details.headerItemInfoBag } only %}
        {% for providerId in headerItemInfoBag.getProviderIds() %}
          <div class="provider">For service: <strong>{{ providerId }}</strong></div>
          {% set headerMatchNames = headerItemInfoBag.getMatchingHeaderNames(providerId)|join(' / ') %}
          <div class="matching">Matching: {{ headerMatchNames }}</div>
          {% set headerNonMatchNames = headerItemInfoBag.getNonMatchingHeaderNames(providerId)|join(' / ') %}
          <div class="not-matching">Not matching: {{ headerNonMatchNames }}</div>
          <details>
            <summary>{{"Details..." }}</summary>
            {% for heading, isMatchValue in {'Match': TRUE, 'NoMatch': FALSE} %}
              <strong>{{ heading }}</strong><br />
              <ul>
                {% for headerItemInfo in headerItemInfoBag.infos %}
                  {# headerItemMatch \Geeks4change\UntrackEmailAnalyzer\Analyzer2\Data\Header\HeaderItemMatch #}
                  {% for headerItemMatch in headerItemInfo.matches %}
                    {% if headerItemMatch.isMatch == isMatchValue and headerItemMatch.providerId == providerId %}
                      <li><strong>{{ headerItemInfo.headerItem.name }}</strong>: {{ headerItemInfo.headerItem.value }}</li>
                    {% endif %}
                  {% endfor %}
                {% endfor %}
              </ul>
            {% endfor %}
          </details>
        {% endfor %}
      {% endwith %}


      {# urlItemInfoBag \Geeks4change\UntrackEmailAnalyzer\Analyzer\Result\Url\UrlItemInfoBag #}
      {% with { urlItemInfoBag: result.details.urlItemInfoBag } only %}
        <h3>{{"All extracted links and image urls" }}</h3>
        <div class="links">{{ urlItemInfoBag.getLinks().urlItemInfos|length }} Links</div>
        <div class="images">{{ urlItemInfoBag.getImages().urlItemInfos|length }} Images</div>
        <details>
          <summary>{{"Details..." }}</summary>
          {% for urlListType, urlItemInfoBag in {'Links': urlItemInfoBag.getLinks(), 'Images': urlItemInfoBag.getImages() } %}
            <strong>{{ urlItemInfoBag.urlItemInfos|length }} {{ urlListType }} Urls</strong><br />
            {% for urlItemInfo in urlItemInfoBag.urlItemInfos %}
              <li>{{ urlItemInfo.urlItem.url }}:
                {% if urlItemInfo.redirectInfo %}
                  => {{ urlItemInfo.redirectInfo.redirect }}
                {% endif %}
                {% for match in urlItemInfo.matches %}
                  {# match \Geeks4change\UntrackEmailAnalyzer\Analyzer\Result\Url\Match\ProviderMatch #}
                  found {{ match.isUserTracking ? 'spying ' : '' }}url "{{ match.name }}" from {{ match.providerId }}
                {% endfor %}
                {% if urlItemInfo.analyticsInfo %}
                  with Analytics: {{ urlItemInfo.analyticsInfo.type.value }}
                  keys: ({{ urlItemInfo.analyticsInfo.keys|join('/') }})
                {% endif %}
              </li>
            {% endfor %}
          {% endfor %}
        </details>
      {% endwith %}


      <h4>{{"Domains and cname aliases" }}</h4>
      <div class="cnames">{% for cnameChain in result.details.cnameChainList.cnaneChainsByDomain %}
          {# cnameChain \Geeks4change\UntrackEmailAnalyzer\Analyzer\AnalyzerResult\ResultDetails\CnameChain #}
        <ul class="cname">
          <li> {{ cnameChain.domain }} => {{ cnameChain.aliasDomains|join(' => ') }}</li>
        </ul>
      {% endfor %}</div>

</div>
